#include <Alert.h>
#include <Invoker.h>

#include "ResourceUtils.h"

#include "BMountains.h"
#include "MountainView.h"

const char* app_signature = "application/x-vnd.rickb-bemountains";

/*----------------------------------------------------------------------------------------
	° BMountains
------------------------------------------------------------------------------------------*/

BMountainApp::BMountainApp() : BApplication(app_signature)
{
	BMimeType mime(app_signature);
	if(!mime.IsInstalled())
		mime.Install();
}

BMountainApp::~BMountainApp()
{
}

/*----------------------------------------------------------------------------------------
	° ReadyToRun
------------------------------------------------------------------------------------------*/
void BMountainApp::ReadyToRun()
{
	entry_ref ref;
	status_t status = be_roster->FindApp(app_signature,&ref);
	BFile file(&ref, B_READ_ONLY);
	BResources res(&file);

	BWindow* win = cast_as(ResourceUtils::RestoreFromResource(&res, 'ARCV', 1), BWindow);
	if(win){
		win->AddCommonFilter( new ConfigViewFilter());
		win->Show();
	}else
	{
		BInvoker* invoker = new BInvoker(new BMessage(B_QUIT_REQUESTED),this);
		(new BAlert("Error!","Couldn't find resources. Try running mimeset","Ok"))->Go(invoker);
	}
}

/*----------------------------------------------------------------------------------------
	° main
------------------------------------------------------------------------------------------*/

int main(int, char**)
{	
	new BMountainApp();
	be_app->Run();
	
	return 0;
}