#ifndef _MOUNTAINRENDERER_H_
#define _MOUNTAINRENDERER_H_

#include <Bitmap.h>

#include "paint.h"
#include "crinkle.h"

class MountainRenderer // : public BArchivable
{
public:
	MountainRenderer();
	
	void PlotNextColumn(BBitmap*);

// WARNING! WARNING! PORTED CODE FOLLOWS WARNING! WARNING! //		
	void init_graphics();
	
private:
	void plot_pixel(int x,int y,Gun value);
	Col *next_col ( int paint, int reflec);
	void plot_column(int p,int map,int reflec,int snooze);
	void scroll_screen();

	void init_artist_variables();
	void set_clut (int max_col,Gun *red,Gun *green,Gun *blue);
	
	Col *mirror(Height *a,Height *b,Height *shadow);
	Col *camera(Height *a,Height *b,Height *shadow);
	Col *makemap (Height *a,Height *b,Height *shadow);
	Height *extract (Strip *s);
	int project (int x,Height y);
	Col get_col (Height p,Height p_minus_x,Height p_minus_y,Height shadow);

public:	
	int	mCurCol;
	bool mScrolling;
	
	float pre_shift;
	
	BBitmap* mImage;
	
	int s_height, s_width;
	int mapwid;
	
	Parm fold_param;
	float vstrength; /* strength of vertical light source */
	float lstrength; /* strength of vertical light source */
	int base;      /* parity flag for mirror routine */

	int repeat;
 	int map;
 	int reflec;

	int plot_x, plot_y1, plot_y2;
	int last_plot_x;
	int plot_saved;
	rgb_color plot_col;
	rgb_color table[256];
	
	Fold* top;
	int levels;
	int stop;
	int smooth;
	int cross;
	int slope;
	int snooze_time;
	int request_clear;
	int n_col;
	int band_size;
	float mix;
	float midmix;
	float f_dim;
	float start;
	float mean;
	float varience;
	float shift;
	float delta_shadow;
	float stretch;
	float contour;
	float ambient;
	float contrast;
	float vfract;
	float altitude;
	float distance;
	double phi;
	double alpha;
	double shadow_slip;
	double shadow_register;
	double cos_phi;
	double sin_phi;
	double tan_phi;
	double x_fact;
	double y_fact;
	Height sealevel;
	Height forceheight;
	int width;
	int seed;

	double vangle;
	double tan_vangle;
	float vscale;
	float viewpos;
	float viewheight;
	float focal;
	Height *shadow;
	Height *a_strip, *b_strip;
};

#endif