#ifndef _MOUNTAINVIEW_H
#define _MOUNTAINVIEW_H

#include <MessageFilter.h>

#include "BitmapView.h"

class MountainRenderer;

_EXPORT class MountainView : public BitmapView
{
friend class ConfigViewFilter;
public:
	static BArchivable* Instantiate(BMessage* archive);
	virtual status_t Archive(BMessage* archive,bool deep = true) const;

	MountainView(BMessage* archive);

	MountainView(BRect frame, const char* name,
						uint32 mode = B_FOLLOW_ALL_SIDES,
						uint32 flags = B_WILL_DRAW);
	virtual ~MountainView();

	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage* msg);
	
protected:
	ConfigViewFilter* mViewFilter;
	void ChangeSettings(MountainRenderer*);
	
private:
	void Start();
	static int32 thread_func(void*);
	
	bool mAllDone;
	thread_id mThread;

	MountainRenderer* mRenderer;
};

/*----------------------------------------------------------------------------------------
	° ConfigViewFilter
------------------------------------------------------------------------------------------*/

class ConfigViewFilter : public BMessageFilter
{
friend class MountainView;
public:
	ConfigViewFilter();
	~ConfigViewFilter();	
	
	virtual filter_result Filter(BMessage*, BHandler**);
	
protected:
	MountainView* mMountainView;
};

#endif