#include "MountainRenderer.h"
#include "BlanketModule.h"

class ConfigView;

#pragma export on

// Main module class
class MountainModule : public BlanketModule
{
public:
	MountainModule(BMessage* message);
	~MountainModule();
	
	virtual	status_t Archive(BMessage *into, bool deep = true) const;
	
	BlanketModule::Saver* InstantiateSaver(BView *v, bool /*preview*/);
	BlanketModule::Config* InstantiateConfig(BView *v);
	
	MountainRenderer* mRenderer;
};

// Screen saver painter
class MountainSaver : public BlanketModule::Saver
{
public:
	MountainSaver(BlanketModule *owner, BView* v);
	~MountainSaver();
	
	void Tick();

protected:
	MountainRenderer* mRenderer;
	BBitmap* mImage;
};

// Basic configuration panel
class MountainConfig : public BlanketModule::Config
{
public:
	MountainConfig(BlanketModule *owner, BView* view);
	virtual ~MountainConfig();
};

#pragma export reset